package com.fuzamei.dao;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.fuzamei.entity.AccountInfo;
import com.fuzamei.entity.Role;
import com.fuzamei.entity.Token;
import com.fuzamei.entity.User;
import com.fuzamei.mapperInterface.AccountInfoInterface;
import com.fuzamei.mapperInterface.RoleInterface;
import com.fuzamei.mapperInterface.TokenInterface;
import com.fuzamei.mapperInterface.UserAccountInterface;
import com.fuzamei.mapperInterface.UserInterface;
import com.fuzamei.utils.PageDTO;

@Repository(value = "userDao")
public class UserDao {
	@Autowired
	private UserInterface userMapper;
	@Autowired
	private AccountInfoInterface accountInfoInterface;
	@Autowired
	private UserAccountInterface userAccountInterface;
	@Autowired
	private RoleInterface roleInterface;
	@Autowired
	private TokenInterface tokenInterface;
	public List<User> getUserCount(User user) {
		// TODO 获取该用户的count
		return userMapper.getUserCount(user);
	}
	public int insertUsers(List<User> listUsers) {
		// TODO Auto-generated method stub
		return userMapper.insertUsers(listUsers);
	}
	public int addUserToUser(User user) {
		// TODO Auto-generated method stub
		return userMapper.addUserToUser(user);
	}
	public int addUserToUserRole(User user) {
		// TODO Auto-generated method stub
		return userMapper.addUserToUserRole(user);
	}
	public int updateUserById(User user) {
		// TODO Auto-generated method stub
		return userMapper.updateUserById(user);
	}
	public int updataRoleById(User user) {
		// TODO Auto-generated method stub
		return userMapper.updataRoleById(user);
	}
	public PageDTO getUsers(User user,int page,int rows) {
		// TODO Auto-generated method stub
		PageDTO pageDTO = new PageDTO();
		int count = 0;
		List<User> users = new ArrayList<User>();
		int startNum = (page-1)*rows;
		Map<String,Object> mapParam = new HashMap<String,Object>();
		mapParam.put("role_name", user.getRole_name());
		mapParam.put("account", user.getAccount());
		mapParam.put("person_name", user.getPerson_name());
		mapParam.put("startNum", startNum);
		mapParam.put("endNum", rows);
//		return userMapper.getUsers(user);
		try{
			users =  userMapper.getUsersByPage(mapParam);
			count = userMapper.getUsers(mapParam);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		pageDTO.setTotal(count);
		pageDTO.setRows(users);
		return pageDTO;
	}
	public User findUserById(User user) {
		// TODO Auto-generated method stub
		return userMapper.findUserById(user);
	}
	public List<AccountInfo> getAllAccount() {
		// TODO Auto-generated method stub
		return accountInfoInterface.getAllAccount();
	}
	public int insertAccountInfo(List<Map<String, Object>> accountList) {
		// TODO Auto-generated method stub
		return accountInfoInterface.insertAccountInfo(accountList);
	}
	public int insertUserAccount(List<Map<String, Object>> accountList) {
		// TODO Auto-generated method stub
		return userAccountInterface.insertUserAccount(accountList);
	}
	public List<Role> getAllRoles() {
		// TODO Auto-generated method stub
		return roleInterface.getAllRoles();
	}
	public User findUserById(String userId) {
		// TODO Auto-generated method stub
		return userMapper.findUserById1(userId);
	}
	public Token getTokenById(Token token) {
		// TODO Auto-generated method stub
		return tokenInterface.getTokenById(token);
	}
	public int insertToken(Token token) {
		// TODO Auto-generated method stub
		return tokenInterface.insertToken(token);
	}
	public int updateToken(Token token) {
		// TODO Auto-generated method stub
		return tokenInterface.updateToken(token);
	}
	public List<AccountInfo> getAccountInfoByUser(String userId) {
		// TODO Auto-generated method stub
		return accountInfoInterface.getAccountInfoByUser(userId);
	}
	public int updateBatchAccountById(Map<String, Map<String, Object>> parameter, List<String> cloumn) {
		// TODO Auto-generated method stub
		return accountInfoInterface.updateBatchAccountById(parameter, cloumn);
	}
	

}
